﻿@model CalendarNoLogin.Controllers.CalendarViewModelJson
@{
    ViewBag.Title = "Home Page";
}
<link rel="stylesheet" href="~/Content/MyCalendarStyle.css" />
<div class="modal fade" id="NewEventModal" role="dialog">
    <div class="modal-dialog">
        <!-- Modal content-->
        <div class="modal-content">
            <div class="modal-header">
                <button type="button" class="close" data-dismiss="modal">&times;</button>
                <h4 class="modal-title">Modal Header</h4>
            </div>
            <div class="modal-body" id="NewEventContent">
            </div>
            <div class="modal-footer">
                <button type="button" class="btn btn-default" data-dismiss="modal">Close</button>
            </div>
        </div>
    </div>
</div>
<button id="NewEventModalTrigger" type="button" class="invisible" data-toggle="modal" data-target="#NewEventModal"></button>
<!--different calendar is responsible for different dot color-->
<div class="myowncalendar">
    <table id="calendarTable">
        <thead>
            <tr>
                <th><button type="button" class="btn" onclick="PreviousWeek()">Previous</button></th>
                <th>Mon</th>
                <th>Tue</th>
                <th>Wed</th>
                <th>Thu</th>
                <th>Fri</th>
                <th>Sat</th>
                <th>Sun</th>
                <th><button type="button" class="btn" onclick="NextWeek()">Next</button></th>
            </tr>
        </thead>
        <tfoot>
            <tr>
                <th><button type="button" class="btn" onclick="PreviousWeek()">Previous</button></th>
                <th>Mon</th>
                <th>Tue</th>
                <th>Wed</th>
                <th>Thu</th>
                <th>Fri</th>
                <th>Sat</th>
                <th>Sun</th>
                <th><button type="button" class="btn" onclick="NextWeek()">Next</button></th>
            </tr>
        </tfoot>
    </table>
</div>

@section Scripts {
    @Scripts.Render("~/Scripts/jquery-1.12.4.min.js");
    @Scripts.Render("~/bundles/jqueryval");
    @Styles.Render("~/Content/themes/base/css");
    @Scripts.Render("~/bundles/jqueryui");
    @Scripts.Render("~/bundles/bootstrap");
    <script type="text/javascript">
        jQuery('body').on('click', '[data-toggle=dropdown]', function () {
            var opened = $(this).parent().hasClass("open");
            if (!opened) {
                $('.btn-group').addClass('open');
                $("button.multiselect").attr('aria-expanded', 'true');
            } else {
                $('.btn-group').removeClass('open');
                $("button.multiselect").attr('aria-expanded', 'false');
            }
        });//hack multiselects for modal

        function ParseForm() {
            var eventName = $('#EventName').val();
            var eventDate = $('#EventDate').val();
            var eventBegin = $('#BeginTime').val();
            var eventEnd = $('#EndTime').val();
            var persons = $('#mysuperpicker').val();
            var eventID = $('#EventId').val();
            var eventTimeStamp = $('#EventTimeStamp').val();

            return {
                EventName: eventName,
                EventDate: eventDate,
                EventBegin: eventBegin,
                EventEnd: eventEnd,
                Logins: persons,
                ID: eventID,
                TimeStamp: eventTimeStamp,
            };
        }

        function SaveNewEvent() {
            var req = ParseForm();
            CalendarPost("/Home/CreateNewEvent", req);
        }

        function ShowPartialInModal(url) {
            $('#NewEventContent').load(url, function (response, status, request) {
                if (status == 'error') {
                }
                else {
                    $('#NewEventModalTrigger').click();
                }
            });
        }

        function NewEvent(date) {
            ShowPartialInModal("/Home/NewEvent?" + $.param({ Date: date }));
        }

        function EditEvent(guid) {
            ShowPartialInModal('/Home/EditEvent?' + $.param({ guid: guid }));
        }

        function AcceptInvitation() {
            var req = {
                guid: $('#EventId').val(),
                timeStamp: $('#EventTimeStamp').val(),
            }
            CalendarPost("/Home/AcceptInvitation", req);
        }

        function DenyInvitation() {
            var req = {
                guid: $('#EventId').val(),
                timeStamp: $('#EventTimeStamp').val(),
            }
            CalendarPost("/Home/DenyInvitation", req);
        }

        function CalendarPost(url, req) {
            $.post(url, req, function (data) {
                if (data.success == true) {
                    window.location.href = '/Home/GetCalendar';
                }
                else {
                    alert(data.responseText);
                }
            });
        }

        function RemoveEvent() {
            var req = {
                guid: $('#EventId').val(),
                timeStamp: $('#EventTimeStamp').val(),
            }
            CalendarPost("/Home/RemoveEvent", req);
        }

        function PreviousWeek() {
            window.location.replace('GetCalendar?start=-1');
        }

        function NextWeek() {
            window.location.replace('GetCalendar?start=1');
        }

        function formatDate(origdate) {
            var monthNames = [
                "Jan", "Feb", "Mar",
                "Apr", "May", "Jun", "Jul",
                "Aug", "Sep", "Oct",
                "Nov", "Dec"
            ];
            date = new Date(origdate);
            var day = date.getDate();
            var monthIndex = date.getMonth();
            var year = date.getFullYear();
            var calendarString = '<span onclick="NewEvent(' + origdate + ')">'
            calendarString += day + ' ' + monthNames[monthIndex] + ' ' + year;
            calendarString += '</span>';
            return calendarString;
        }

        var model = '@Html.Raw(@Model.Content)';
        model = JSON.parse(model);

        var createdString = '';

        for (var i = 0; i < model.Weeks.length; i++) {
            var week = model.Weeks[i];
            createdString += '<tr>';
            createdString += '<td>' + week.WeekNumber + '</td>';
            for (var j = 0; j < week.Days.length; j++) {
                var day = week.Days[j];
                createdString += '<td><span class="date">';
                var date = Date.parse(day.Date);
                createdString += formatDate(date);
                if (day.Events.length > 0) {
                    createdString += '<ul>';
                    for (var k = 0; k < day.Events.length; k++) {
                        var event = day.Events[k];
                        createdString += '<li><span class="event">';
                        createdString += event.Title;
                        createdString += '</span><span class="title" onclick="EditEvent(\'' + event.Guid + '\')"';
                        createdString += '>';
                        createdString += event.Begin + '-' + event.End;
                        createdString += '</span>';
                    }
                    createdString += '</ul>';
                }

                createdString += '</span></td>';
            }
            createdString += '<td>' + week.WeekNumber + '</td>';
            createdString += '</tr>';
        }

        $('#calendarTable').append(createdString);
    </script>
}